program test
!
  use com_dfs, only : com_dfs__ini
  use prm_phconst, only : ER, PI, PI2, ER, OMG, GRAV
  use fft_y, only : fft_y__ini, fft_y__g2w, fft_y__g2w_uv, fft_y__w2g, fft_y__w2g_dy, fft_y__w2g_uv
  use fft_y, only : fft_y__g2w_cheong, fft_y__w2g_cheong, fft_y__w2g_dy_cheong
  use fft_y, only : fft_y__g2w_cheonglike, fft_y__w2g_cheonglike
  use fft_y, only : fft_y__g2w_orszag, fft_y__w2g_orszag
  use fft_y, only : grid2sin, sin2grid, grid2cos, cos2grid
  use monit, only : monit__ini, monit__output
  use grads, only : grads__outxy
!
  implicit none
!
!  integer,parameter :: JCN_DFS = 0 !! Old method and Cheong's basis functions
!  integer,parameter :: JCN_DFS = 1 !! New method to calculate expantion coefficients
  integer,parameter :: JCN_DFS = 2 !! New method to calculate expantion coefficients and New basis functions

  integer,parameter :: JCN_GRID = 0   !! colat=PI*(j+0.5)/JMAX0, j=0,...,JMAX0-1
!  integer,parameter :: JCN_GRID = 1   !! colat=PI*j/JMAX0, j=0,...,JMAX0   (JMAX=JMAX0+1)
!  integer,parameter :: JCN_GRID = -1  !! colat=PI*j/JMAX0, j=1,...,JMAX0-1 (JMAX=JMAX0-1)

  
!  integer,parameter :: IMAX = 16
!  integer,parameter :: JMAX = 8 + JCN_GRID
!  integer,parameter :: NMAX = 7
!
  integer,parameter :: IMAX = 128            !! About 300km resolution
  integer,parameter :: JMAX = 64+JCN_GRID
!  integer,parameter :: NMAX = 63             !! Linear grid
  integer,parameter :: NMAX = 42            !! Quadric grid
!
!  integer,parameter :: IMAX = 160            !! 250km resolution
!  integer,parameter :: JMAX = 80+JCN_GRID
!  integer,parameter :: NMAX = 79             !! Linear grid
!  integer,parameter :: NMAX = 53             !! Quadric grid
!
!  integer,parameter :: IMAX = 320            !! 120km resolution
!  integer,parameter :: JMAX = 160+JCN_GRID
!  integer,parameter :: NMAX = 159            !! Linear grid
!  integer,parameter :: NMAX = 106            !! Quadric grid
!
!  integer,parameter :: IMAX = 640            !! 60km resolution
!  integer,parameter :: JMAX = 320+JCN_GRID
!  integer,parameter :: NMAX = 319            !! Linear grid
!  integer,parameter :: NMAX = 213            !! Quadric grid
!
!  integer,parameter :: IMAX = 1920           !! 20km resolution
!  integer,parameter :: JMAX = 960+JCN_GRID   !! J is from North to South
!  integer,parameter :: NMAX = 959            !! Linear grid
!  integer,parameter :: NMAX = 639            !! Quadric grid
!
!  integer,parameter :: IMAX = 3840           !! 10km resolution
!  integer,parameter :: JMAX = 1920+JCN_GRID  !! J is from North to South
!  integer,parameter :: NMAX = 1919           !! Linear grid
!  integer,parameter :: NMAX = 1279           !! Quadric grid
!  integer,parameter :: NMAX = 959            !! Cubic grid
!
!  integer,parameter :: IMAX = 7680           !! 5km resolution
!  integer,parameter :: JMAX = 3840+JCN_GRID  !! J is from North to South
!  integer,parameter :: NMAX = 3839           !! Linear grid
!  integer,parameter :: NMAX = 2559           !! Quadric grid
!  integer,parameter :: NMAX = 1919           !! Cubic grid
!
!  integer,parameter :: IMAX = 15360          !! 2.6km resolution
!  integer,parameter :: JMAX = 7680+JCN_GRID  !! J is from North to South
!  integer,parameter :: NMAX = 7679           !! Linear grid
!  integer,parameter :: NMAX = 5119           !! Quadric grid
!  integer,parameter :: NMAX = 3839           !! Cubic grid
!
!  integer,parameter :: IMAX = 20480          !! 2.0km resolution
!  integer,parameter :: JMAX = 10240+JCN_GRID !! J is from North to South
!  integer,parameter :: NMAX = 10239          !! Linear grid
!  integer,parameter :: NMAX = 6826           !! Quadric grid
!  integer,parameter :: NMAX = 5119           !! Cubic grid
!
!  integer,parameter :: IMAX = 30720          !! 1.3km resolution
!  integer,parameter :: JMAX = 15360+JCN_GRID !! J is from North to South
!  integer,parameter :: NMAX = 15359          !! Linear grid   
!  integer,parameter :: NMAX = 10239          !! Quadric grid
!  integer,parameter :: NMAX = 7679           !! Cubic grid

  
  integer,parameter :: JMAX_INTERP = JMAX*10+1
!xx  integer,parameter :: JMAX_INTERP = JMAX
!
  integer,parameter :: MMAX = NMAX
  integer,parameter :: NNUM = NMAX + 1
!
  real(8),parameter :: dlon = pi2/imax
  real(8),parameter :: dlat = pi/(jmax-jcn_grid)
  
  real(8) :: alon(imax)
  real(8) :: sinlon(imax)
  real(8) :: coslon(imax)
  real(8) :: alat(jmax)
  real(8) :: ylat(jmax)
  real(8) :: coslat(jmax)
  real(8) :: coslat_inv(jmax)
  real(8) :: sinlat(jmax)
  real(8) :: weight(jmax)
  
  real(8) :: acolat_interp(jmax_interp)
  real(8) :: ylat_interp(jmax_interp)
!
! ==================================================================
!
  call initialize
!
  call main
!
!
!******************************************************************
contains
!******************************************************************


subroutine initialize
!
  integer :: i,j
  real(8) :: work(JMAX)
!
  call com_dfs__ini( jcn_dfs, jcn_grid, imax, jmax, mmax, nmax )
  call fft_y__ini( imax, jmax, mmax, alat, weight ) !IN[3],OUT[2]
  
  coslat(:) = cos(alat(:))
  sinlat(:) = sin(alat(:))
  coslat_inv(:) = 1.0d0/coslat(:)
  ylat(:) = alat(:)*180.0d0/PI
!
  do i=1,imax
    alon(i) = dlon*(i-1)    !## 0 <= alon < 2*pi
    sinlon(i) = sin(alon(i))
    coslon(i) = cos(alon(i))
  end do
!
  do j=1,JMAX_INTERP
    acolat_interp(j) = PI*(j-1)/(JMAX_INTERP-1)
!xx    acolat_interp(j) = PI*(j-0.5d0)/JMAX_INTERP
    ylat_interp(j) = ( PI/2 - acolat_interp(j) )*180.0d0/PI
  end do
!
end subroutine initialize


!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&



subroutine main
!
  complex(8) :: qdata(nnum,0:mmax)
  real(8) :: data_save(imax, jmax)
  real(8) :: data(imax, jmax)
  real(8) :: datay(imax, jmax)
  real(8) :: data_m(0:mmax, jmax)
  real(8) :: data_interp(jmax_interp)
  real(8) :: colat, ww
  integer :: m,i,j,n
!
! =====================================================================
! 
  data_save=0.0d0
  do j=1,jmax
    if ( ylat(j) >= 30.0d0 ) then
      data_save(:,j)=1.0d0
      data_m(:,j)=1.0d0
    else
      data_save(:,j)=0.0d0
      data_m(:,j)=0.0d0
    end if
!    if ( j <= 1 ) then
!      data_save(:,j)=0.0d0
!      data_m(:,j)=0.0d0
!    end if
  end do
  
  call grads__outxy( "initial", 1, MMAX+1, JMAX, ylat, data_m ) !IN

  data(:,:) = data_save(:,:)
  
  call fft_y__g2w &
   &( data,       &!IN
   &  qdata   )    !INOUT

  call fft_y__w2g &
   &( qdata,      &!IN
   &  data   )     !OUT
  call fft_y__w2g_dy &
   &( qdata,      &!IN
   &  datay    )   !OUT

  do j=1,jmax
    do m=0,mmax
      i=m*2+1
      data_m(m,j) = data(i,j)
    end do
  end do
  call grads__outxy( "new", 1, MMAX+1, JMAX, ylat, data_m ) !IN

  do j=1,jmax
    do m=0,mmax
      i=m*2+1
      data_m(m,j) = datay(i,j)
    end do
  end do
  call grads__outxy( "new_dy", 1, MMAX+1, JMAX, ylat, data_m ) !IN

  data_interp(:) = 0.0d0
  do j=1,JMAX_INTERP
    colat = acolat_interp(j)
    do n=1,nnum
      ww = real( qdata(n,2), kind=8 )
      data_interp(j) = data_interp(j) + ww*sin(colat)*sin(n*colat)
!      data_interp(j) = sin(colat)
    end do
  end do
!xx  write(6,*) "data_interp_new(:)=",data_interp(:)
  call grads__outxy( "new_interp", 1, 1, jmax_interp, ylat_interp, data_interp ) !IN
  
! ---------------------------------------------------------------------
  
  data(:,:) = data_save(:,:)

  call fft_y__g2w_cheong &
   &( data,       &!IN
   &  qdata   )    !INOUT

  call fft_y__w2g_cheong &
   &( qdata,      &!IN
   &  data   )     !OUT
  call fft_y__w2g_dy_cheong &
   &( qdata,      &!IN
   &  datay    )   !OUT

!xx  write(6,*) "qdata_cheong(:,2)=",qdata(:,2)
  
  do j=1,jmax
    do m=0,mmax
      i=m*2+1
      data_m(m,j) = data(i,j)
    end do
  end do
  call grads__outxy( "cheong", 1, MMAX+1, jmax, ylat, data_m ) !IN

  do j=1,jmax
    do m=0,mmax
      i=m*2+1
      data_m(m,j) = datay(i,j)
    end do
  end do
  call grads__outxy( "cheong_dy", 1, MMAX+1, jmax, ylat, data_m ) !IN

  data_interp(:) = 0.0d0
  do j=1,JMAX_INTERP
    colat = acolat_interp(j)
    do n=1,nnum
      ww = real( qdata(n,2), kind=8 )
      data_interp(j) = data_interp(j) + ww*sin(colat)*sin(n*colat)
!      data_interp(j) = sin(colat)
    end do
  end do
!xx  write(6,*) "data_interp_cheong(:)=",data_interp(:)
  call grads__outxy( "cheong_interp", 1, 1, jmax_interp, ylat_interp, data_interp ) !IN

! ---------------------------------------------------------------------
  
  data(:,:) = data_save(:,:)

  call fft_y__g2w_orszag &
   &( data,       &!IN
   &  qdata   )    !INOUT

  call fft_y__w2g_orszag &
   &( qdata,      &!IN
   &  data   )     !OUT
  call fft_y__w2g_dy &
   &( qdata,      &!IN
   &  datay    )   !OUT

  do j=1,jmax
    do m=0,mmax
      i=m*2+1
      data_m(m,j) = data(i,j)
    end do
  end do
  call grads__outxy( "orszag", 1, MMAX+1, jmax, ylat, data_m ) !IN
      
end subroutine main


!&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&


end program test
